> ## Documentation Index
> Fetch the complete documentation index at: https://docs.gp.scale.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List Test Cases

> ### Description
List all test cases for a selected dataset.



## OpenAPI

````yaml https://app.stainlessapi.com/api/spec/documented/sgp/openapi.yml get /v4/evaluation-datasets/{evaluation_dataset_id}/test-cases
openapi: 3.1.0
info:
  title: EGP API V4
  description: >-
    This is the parent API for all EGP APIs. If you are looking for the EGP API,
    please go to https://api.egp.scale.com/docs.
  contact:
    name: Scale Generative AI Platform
    url: https://scale.com/genai-platform
  version: 0.1.0
servers:
  - url: https://api.egp.scale.com
security: []
tags:
  - name: Models
    description: Model API.
paths:
  /v4/evaluation-datasets/{evaluation_dataset_id}/test-cases:
    get:
      tags:
        - Evaluation Datasets
      summary: List Test Cases
      description: |-
        ### Description
        List all test cases for a selected dataset.
      operationId: GET-V4-/evaluation-datasets/{evaluation_dataset_id}/test-cases
      parameters:
        - name: evaluation_dataset_id
          in: path
          required: true
          schema:
            type: string
            title: Evaluation Dataset Id
        - name: page
          in: query
          required: false
          schema:
            type: integer
            minimum: 1
            description: >-
              Page number for pagination to be returned by the given endpoint.
              Starts at page 1
            default: 1
            title: Page
          description: >-
            Page number for pagination to be returned by the given endpoint.
            Starts at page 1
        - name: limit
          in: query
          required: false
          schema:
            type: integer
            maximum: 10000
            minimum: 1
            description: >-
              Maximum number of artifacts to be returned by the given endpoint.
              Defaults to 100 and cannot be greater than 10k.
            default: 100
            title: Limit
          description: >-
            Maximum number of artifacts to be returned by the given endpoint.
            Defaults to 100 and cannot be greater than 10k.
        - name: include_archived
          in: query
          required: false
          schema:
            type: boolean
            default: false
            title: Include Archived
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PaginatedTestCaseVersionResponse'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      x-codeSamples:
        - lang: Python
          source: |-
            import os
            from scale_gp import SGPClient

            client = SGPClient(
                api_key=os.environ.get("SGP_API_KEY"),  # This is the default and can be omitted
            )
            page = client.evaluation_datasets.test_cases.list(
                evaluation_dataset_id="evaluation_dataset_id",
            )
            page = page.items[0]
            print(page)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/stainless-sdks/sgp-go\"\n\t\"github.com/stainless-sdks/sgp-go/option\"\n)\n\nfunc main() {\n\tclient := sgp.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\tpage, err := client.EvaluationDatasets.TestCases.List(\n\t\tcontext.TODO(),\n\t\t\"evaluation_dataset_id\",\n\t\tsgp.EvaluationDatasetTestCaseListParams{},\n\t)\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", page)\n}\n"
components:
  schemas:
    PaginatedTestCaseVersionResponse:
      properties:
        items:
          items:
            $ref: '#/components/schemas/TestCaseVersionResponse'
          type: array
          title: Items
          description: The data returned for the current page.
        total_item_count:
          type: integer
          title: Total Item Count
          description: The total number of items of the query
        current_page:
          type: integer
          title: Current Page
          description: The current page number.
        items_per_page:
          type: integer
          title: Items Per Page
          description: The number of items per page.
      type: object
      required:
        - items
        - total_item_count
        - current_page
        - items_per_page
      title: PaginatedTestCaseVersionResponse
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    TestCaseVersionResponse:
      oneOf:
        - $ref: '#/components/schemas/GenerationTestCaseVersionResponse'
        - $ref: '#/components/schemas/FlexibleTestCaseVersionResponse'
      title: TestCaseVersionResponse
      discriminator:
        propertyName: schema_type
        mapping:
          FLEXIBLE:
            $ref: '#/components/schemas/FlexibleTestCaseVersionResponse'
          GENERATION:
            $ref: '#/components/schemas/GenerationTestCaseVersionResponse'
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
        input:
          title: Input
        ctx:
          type: object
          title: Context
          additionalProperties: true
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    GenerationTestCaseVersionResponse:
      properties:
        evaluation_dataset_id:
          type: string
          title: Evaluation Dataset Id
          description: The ID of the associated evaluation dataset.
        schema_type:
          type: string
          const: GENERATION
          title: Schema Type
          default: GENERATION
        test_case_data:
          anyOf:
            - $ref: '#/components/schemas/ArtifactSchemaGeneration'
            - $ref: '#/components/schemas/SchemaGenerationBase'
          title: Test Case Data
        chat_history:
          title: Chat History
          description: >-
            Used for tracking previous chat interactions for multi-chat test
            cases
          additionalProperties: true
          type: object
        autogenerated:
          type: boolean
          title: Autogenerated
          description: Boolean to track whether or not the test case is autogenerated
          can_patch: false
        test_case_metadata:
          title: Test Case Metadata
          description: Metadata for the test case
          additionalProperties: true
          type: object
        invalidated_at:
          title: Invalidated At
          description: >-
            The date and time when the entity was overwritten or deleted in ISO
            format.
          type: string
          format: date-time
        id:
          type: string
          title: Id
          description: The unique identifier of the entity.
        created_at:
          type: string
          format: date-time
          title: Created At
          description: The date and time when the entity was created in ISO format.
        updated_at:
          type: string
          format: date-time
          title: Updated At
          description: The date and time when the entity was last updated in ISO format.
        account_id:
          title: Account Id
          description: The ID of the account that owns the given entity.
          can_patch: false
          optional_in_request: true
          type: string
        created_by_user_id:
          type: string
          title: Created By User Id
          description: The user who originally created the entity.
        created_by_identity_type:
          $ref: '#/components/schemas/IdentifierTypeEnum'
          description: The type of identity that created the entity.
        archived_at:
          title: Archived At
          description: The date and time when the entity was archived in ISO format.
          type: string
          format: date-time
      type: object
      required:
        - evaluation_dataset_id
        - test_case_data
        - autogenerated
        - id
        - created_at
        - updated_at
        - account_id
        - created_by_user_id
        - created_by_identity_type
      title: GenerationTestCaseVersionResponse
    FlexibleTestCaseVersionResponse:
      properties:
        evaluation_dataset_id:
          type: string
          title: Evaluation Dataset Id
          description: The ID of the associated evaluation dataset.
        schema_type:
          type: string
          const: FLEXIBLE
          title: Schema Type
          default: FLEXIBLE
        test_case_data:
          $ref: '#/components/schemas/SchemaFlexible'
        chat_history:
          title: Chat History
          description: >-
            Used for tracking previous chat interactions for multi-chat test
            cases
          additionalProperties: true
          type: object
        autogenerated:
          type: boolean
          title: Autogenerated
          description: Boolean to track whether or not the test case is autogenerated
          can_patch: false
        test_case_metadata:
          title: Test Case Metadata
          description: Metadata for the test case
          additionalProperties: true
          type: object
        invalidated_at:
          title: Invalidated At
          description: >-
            The date and time when the entity was overwritten or deleted in ISO
            format.
          type: string
          format: date-time
        id:
          type: string
          title: Id
          description: The unique identifier of the entity.
        created_at:
          type: string
          format: date-time
          title: Created At
          description: The date and time when the entity was created in ISO format.
        updated_at:
          type: string
          format: date-time
          title: Updated At
          description: The date and time when the entity was last updated in ISO format.
        account_id:
          title: Account Id
          description: The ID of the account that owns the given entity.
          can_patch: false
          optional_in_request: true
          type: string
        created_by_user_id:
          type: string
          title: Created By User Id
          description: The user who originally created the entity.
        created_by_identity_type:
          $ref: '#/components/schemas/IdentifierTypeEnum'
          description: The type of identity that created the entity.
        archived_at:
          title: Archived At
          description: The date and time when the entity was archived in ISO format.
          type: string
          format: date-time
      type: object
      required:
        - evaluation_dataset_id
        - test_case_data
        - autogenerated
        - id
        - created_at
        - updated_at
        - account_id
        - created_by_user_id
        - created_by_identity_type
      title: FlexibleTestCaseVersionResponse
    ArtifactSchemaGeneration:
      properties:
        input:
          type: string
          title: Input
        expected_output:
          title: Expected Output
          type: string
        expected_extra_info:
          $ref: '#/components/schemas/ExtraInfoSchema'
        artifact_ids_filter:
          items:
            type: string
          type: array
          title: Artifact Ids Filter
      type: object
      required:
        - input
        - artifact_ids_filter
      title: ArtifactSchemaGeneration
    SchemaGenerationBase:
      properties:
        input:
          type: string
          title: Input
        expected_output:
          title: Expected Output
          type: string
        expected_extra_info:
          $ref: '#/components/schemas/ExtraInfoSchema'
      type: object
      required:
        - input
      title: SchemaGenerationBase
    IdentifierTypeEnum:
      type: string
      enum:
        - user
        - service_account
      title: IdentifierTypeEnum
    SchemaFlexible:
      properties:
        input:
          anyOf:
            - type: string
            - additionalProperties:
                anyOf:
                  - type: string
                  - type: integer
                  - type: number
                  - items:
                      $ref: '#/components/schemas/FlexibleIOChunk'
                    type: array
                  - items:
                      $ref: '#/components/schemas/ChatMessageV2'
                    type: array
                  - items: {}
                    type: array
                  - additionalProperties: true
                    type: object
                  - $ref: '#/components/schemas/FileIODataType'
                  - type: 'null'
              type: object
          title: Input
        expected_output:
          anyOf:
            - type: string
            - additionalProperties:
                anyOf:
                  - type: string
                  - type: integer
                  - type: number
                  - items:
                      $ref: '#/components/schemas/FlexibleIOChunk'
                    type: array
                  - items:
                      $ref: '#/components/schemas/ChatMessageV2'
                    type: array
                  - items: {}
                    type: array
                  - additionalProperties: true
                    type: object
                  - $ref: '#/components/schemas/FileIODataType'
                  - type: 'null'
              type: object
          title: Expected Output
        expected_extra_info:
          $ref: '#/components/schemas/ExtraInfoSchema'
      type: object
      required:
        - input
      title: SchemaFlexible
    ExtraInfoSchema:
      oneOf:
        - $ref: '#/components/schemas/ChunkExtraInfoSchema'
        - $ref: '#/components/schemas/StringExtraInfoSchema'
      title: ExtraInfoSchema
      discriminator:
        propertyName: schema_type
        mapping:
          CHUNKS:
            $ref: '#/components/schemas/ChunkExtraInfoSchema'
          STRING:
            $ref: '#/components/schemas/StringExtraInfoSchema'
    FlexibleIOChunk:
      properties:
        text:
          type: string
          title: Text
        metadata:
          title: Metadata
          additionalProperties: true
          type: object
      type: object
      required:
        - text
      title: FlexibleIOChunk
    ChatMessageV2:
      oneOf:
        - $ref: '#/components/schemas/UserMessage'
        - $ref: '#/components/schemas/AssistantMessage'
        - $ref: '#/components/schemas/SystemMessage'
      title: ChatMessageV2
      discriminator:
        propertyName: role
        mapping:
          assistant:
            $ref: '#/components/schemas/AssistantMessage'
          system:
            $ref: '#/components/schemas/SystemMessage'
          user:
            $ref: '#/components/schemas/UserMessage'
    FileIODataType:
      anyOf:
        - $ref: '#/components/schemas/ExternalFile'
        - $ref: '#/components/schemas/InternalFile'
      title: FileIODataType
    ChunkExtraInfoSchema:
      properties:
        schema_type:
          type: string
          const: CHUNKS
          title: Schema Type
          default: CHUNKS
        chunks:
          items:
            $ref: '#/components/schemas/ChunkData'
          type: array
          title: Chunks
      type: object
      required:
        - chunks
      title: ChunkExtraInfoSchema
    StringExtraInfoSchema:
      properties:
        schema_type:
          type: string
          const: STRING
          title: Schema Type
          default: STRING
        info:
          type: string
          title: Info
      type: object
      required:
        - info
      title: StringExtraInfoSchema
    UserMessage:
      properties:
        role:
          type: string
          const: user
          title: Role
          description: >-
            The role of the message. Must be set to 'user'.


            A user message is a message from the user to the AI. This should be
            the message used to send end user input to the AI.
          default: user
        content:
          anyOf:
            - type: string
            - items:
                $ref: '#/components/schemas/UserMessageContentParts'
              type: array
          title: Content
          description: >-
            Input from the user. Can either be text or a list of content parts.
            Not all models support image content parts, or multiple parts.
      type: object
      required:
        - content
      title: User Message
    AssistantMessage:
      properties:
        role:
          type: string
          const: assistant
          title: Role
          description: >-
            The role of the message. Must be set to 'assistant'.


            An assistant message is a message from the AI to the client. It is
            different from an agent message in that it cannot contain a tool
            request. It is simply a direct response from the AI to the client.
          default: assistant
        content:
          type: string
          title: Content
          description: Text response from the assistant
      type: object
      required:
        - content
      title: Assistant Message
    SystemMessage:
      properties:
        role:
          type: string
          const: system
          title: Role
          description: >-
            The role of the message. Must be set to 'system'.


            A system message is different from other messages in that it does
            not originate from a party engaged in a user/AI conversation.
            Instead, it is a message that is injected by either the application
            or system to guide the conversation. For example, a system message
            may be used as initial instructions for an AI entity or to tell the
            AI that it did not do something correctly.
          default: system
        content:
          type: string
          title: Content
          description: Text input from the system.
      type: object
      required:
        - content
      title: System Message
    ExternalFile:
      properties:
        uri:
          type: string
          title: Uri
        file_type:
          type: string
          enum:
            - image
            - pdf
          title: File Type
      type: object
      required:
        - uri
        - file_type
      title: ExternalFile
    InternalFile:
      properties:
        file_id:
          type: string
          title: File Id
        file_type:
          type: string
          enum:
            - image
            - pdf
          title: File Type
      type: object
      required:
        - file_id
        - file_type
      title: InternalFile
    ChunkData:
      properties:
        text:
          type: string
          title: Text
        metadata:
          title: Metadata
          additionalProperties: true
          type: object
      type: object
      required:
        - text
      title: ChunkData
    UserMessageContentParts:
      oneOf:
        - $ref: '#/components/schemas/TextUserMessageContentParts'
        - $ref: '#/components/schemas/ImageUrlUserMessageContentParts'
        - $ref: '#/components/schemas/ImageDataUserMessageContentParts'
      title: UserMessageContentParts
      discriminator:
        propertyName: type
        mapping:
          image_data:
            $ref: '#/components/schemas/ImageDataUserMessageContentParts'
          image_url:
            $ref: '#/components/schemas/ImageUrlUserMessageContentParts'
          text:
            $ref: '#/components/schemas/TextUserMessageContentParts'
    TextUserMessageContentParts:
      properties:
        type:
          type: string
          const: text
          title: Type
          default: text
        text:
          type: string
          title: Text
      type: object
      required:
        - text
      title: TextUserMessageContentParts
    ImageUrlUserMessageContentParts:
      properties:
        type:
          type: string
          const: image_url
          title: Type
          default: image_url
        image_url:
          $ref: '#/components/schemas/ImageUrlSubPart'
          description: >-
            Specifies the image URL and level of detail. Only supported by
            OpenAI models
      type: object
      required:
        - image_url
      title: ImageUrlUserMessageContentParts
    ImageDataUserMessageContentParts:
      properties:
        type:
          type: string
          const: image_data
          title: Type
          default: image_data
        image_data:
          $ref: '#/components/schemas/ImageDataSubPart'
          description: Specifies inline image data
      type: object
      required:
        - image_data
      title: ImageDataUserMessageContentParts
    ImageUrlSubPart:
      properties:
        url:
          type: string
          title: Url
          description: 'The URL of the image. Note: only OpenAI supports this.'
        detail:
          title: Detail
          description: >-
            Only used for OpenAI. Corresponds to OpenAI's image detail
            parameter.
          type: string
          enum:
            - low
            - high
            - auto
      type: object
      required:
        - url
      title: ImageUrlSubPart
    ImageDataSubPart:
      properties:
        type:
          type: string
          const: base64
          title: Type
          description: The type of the image data. Only base64 is supported.
          default: base64
        media_type:
          type: string
          title: Media Type
          description: >-
            The media/mime type of the image data. For example, 'image/png'.
            Check providers' documentation for supported media types.
        data:
          type: string
          title: Data
          description: The base64-encoded image data.
        detail:
          title: Detail
          description: >-
            Only used for OpenAI. Corresponds to OpenAI's image detail
            parameter.
          type: string
          enum:
            - low
            - high
            - auto
      type: object
      required:
        - media_type
        - data
      title: ImageDataSubPart

````